﻿using System.Text;
using System.Windows;
using System.Windows.Input;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            MouseDown += Window_MouseDown;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 윈도우 마우스 DOWN 처리하기 - Window_MouseDown(sender, e)

        /// <summary>
        /// 윈도우 마우스 DOWN 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Window_MouseDown(object sender, MouseButtonEventArgs e)
        {
            Point windowMousePoint    = e.GetPosition(null          ); // null 대신 this도 가능하다.
            Point gridMousePoint      = e.GetPosition(this.grid     );
            Point canvasMousePoint    = e.GetPosition(this.canvas   );
            Point rectangleMousePoint = e.GetPosition(this.rectangle);

            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"SENDER          : {sender.GetType()          }");
            stringBuilder.AppendLine($"ORIGINAL SOURCE : {e.OriginalSource.GetType()}");
            stringBuilder.AppendLine($"WINDOW          : {windowMousePoint          }");
            stringBuilder.AppendLine($"GRID            : {gridMousePoint            }");
            stringBuilder.AppendLine($"CANVAS          : {canvasMousePoint          }");
            stringBuilder.AppendLine($"RECTANGLE       : {rectangleMousePoint       }");

            this.messageLabel.Content = stringBuilder.ToString();
        }

        #endregion
    }
}